Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/dynredem_p.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/dynredem_p.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/dynredem_p.F	(revision 1114)
@@ -3,7 +3,8 @@
 !
 c
-      SUBROUTINE dynredem0_p(fichnom,iday_end,phis,nq)
+      SUBROUTINE dynredem0_p(fichnom,iday_end,phis)
       USE IOIPSL
       USE parallel
+      USE infotrac
       IMPLICIT NONE
 c=======================================================================
@@ -23,5 +24,4 @@
 #include "description.h"
 #include "serre.h"
-#include "advtrac.h"
 
 c   Arguments:
@@ -30,5 +30,4 @@
       REAL phis(ip1jmp1)
       CHARACTER*(*) fichnom
-      INTEGER nq
 
 c   Local:
@@ -54,5 +53,4 @@
       INTEGER yyears0,jjour0, mmois0
       character*30 unites
-
 
 c-----------------------------------------------------------------------
@@ -461,6 +459,6 @@
       dims4(3) = idim_s
       dims4(4) = idim_tim
-      IF(nq.GE.1) THEN
-      DO iq=1,nq
+
+      DO iq=1,nqtot
 cIM 220306 BEG
 #ifdef NC_DOUBLE
@@ -472,5 +470,4 @@
       ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 12,ttext(iq))
       ENDDO
-      ENDIF
 c
       dims4(1) = idim_rlonv
@@ -513,6 +510,7 @@
       END
       SUBROUTINE dynredem1_p(fichnom,time,
-     .                     vcov,ucov,teta,q,nq,masse,ps)
+     .                     vcov,ucov,teta,q,masse,ps)
       USE parallel
+      USE infotrac
       IMPLICIT NONE
 c=================================================================
@@ -525,13 +523,12 @@
 #include "comvert.h"
 #include "comgeom.h"
-#include "advtrac.h"
 #include "temps.h"
 #include "control.h"
 
-      INTEGER nq, l
+      INTEGER l
       REAL vcov(ip1jm,llm),ucov(ip1jmp1,llm) 
       REAL teta(ip1jmp1,llm)                   
       REAL ps(ip1jmp1),masse(ip1jmp1,llm)                   
-      REAL q(ip1jmp1,llm,nq)
+      REAL q(ip1jmp1,llm,nqtot)
       CHARACTER*(*) fichnom
      
@@ -559,5 +556,5 @@
       call Gather_Field(ps,ip1jmp1,1,0)
       
-      do iq=1,nq
+      do iq=1,nqtot
         call Gather_Field(q(1,1,iq),ip1jmp1,llm,0)
       enddo
@@ -660,6 +657,5 @@
       END IF
 
-      IF(nq.GE.1) THEN
-      do iq=1,nq 
+      do iq=1,nqtot 
 
          IF (config_inca == 'none') THEN
@@ -731,6 +727,4 @@
       
       ENDDO
-      ENDIF
-
 
 
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/etat0_netcdf.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/etat0_netcdf.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/etat0_netcdf.F	(revision 1114)
@@ -13,4 +13,5 @@
       USE phys_state_var_mod
       USE filtreg_mod
+      USE infotrac
       !
       IMPLICIT NONE
@@ -39,5 +40,5 @@
       REAL :: vvent(iip1, jjm, llm)
       REAL :: t3d(iip1, jjp1, llm), tpot(iip1, jjp1, llm)
-      REAL :: q3d(iip1, jjp1, llm,nqmx), qsat(iip1, jjp1, llm)
+      REAL :: q3d(iip1, jjp1, llm,nqtot), qsat(iip1, jjp1, llm)
       REAL :: tsol(klon), qsol(klon), sn(klon)
       REAL :: tsolsrf(klon,nbsrf), qsolsrf(klon,nbsrf),snsrf(klon,nbsrf) 
@@ -625,5 +626,5 @@
 
 C init pour traceurs
-      call iniadvtrac(nq)
+      call infotrac_init
 C Ecriture
       CALL inidissip( lstardis, nitergdiv, nitergrot, niterh   ,
@@ -649,7 +650,7 @@
      *                phi,w, pbaru,pbarv,time+iday-dayref   )
        print*,'sortie caldyn0'     
-      CALL dynredem0("start.nc",dayref,phis,nqmx)
+      CALL dynredem0("start.nc",dayref,phis)
       print*,'sortie dynredem0'
-      CALL dynredem1("start.nc",0.0,vvent,uvent,tpot,q3d,nqmx,masse ,
+      CALL dynredem1("start.nc",0.0,vvent,uvent,tpot,q3d,masse ,
      .                            psol)
       print*,'sortie dynredem1' 
@@ -743,6 +744,6 @@
       visu_file='Etat0_visu.nc'
       CALL initdynav(visu_file,dayref,anneeref,time_step,
-     .              t_ops, t_wrt, nqmx, visuid)
-      CALL writedynav(visuid, nqmx, itau,vvent ,
+     .              t_ops, t_wrt, visuid)
+      CALL writedynav(visuid, itau,vvent ,
      .                uvent,tpot,pk,phi,q3d,masse,psol,phis)
       else
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/fluxstokenc_p.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/fluxstokenc_p.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/fluxstokenc_p.F	(revision 1114)
@@ -61,5 +61,5 @@
 	CALL initfluxsto_p( 'fluxstoke',
      .  time_step,istdyn* time_step,istdyn* time_step,
-     . nqmx, fluxid,fluxvid,fluxdid) 
+     .  fluxid,fluxvid,fluxdid) 
 	
         ijb=ij_begin
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/gcm.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/gcm.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/gcm.F	(revision 1114)
@@ -14,4 +14,5 @@
       USE mod_grid_phy_lmdz
       USE dimphy
+      USE infotrac
       USE mod_interface_dyn_phys
       USE comgeomphy
@@ -67,5 +68,4 @@
 #include "iniprint.h"
 #include "tracstoke.h"
-#include "advtrac.h"
 
       INTEGER         longcles
@@ -83,5 +83,5 @@
       REAL vcov(ip1jm,llm),ucov(ip1jmp1,llm) ! vents covariants
       REAL teta(ip1jmp1,llm)                 ! temperature potentielle 
-      REAL q(ip1jmp1,llm,nqmx)               ! champs advectes
+      REAL, ALLOCATABLE, DIMENSION(:,:,:) :: q ! champs advectes
       REAL ps(ip1jmp1)                       ! pression  au sol
 c      REAL p (ip1jmp1,llmp1  )               ! pression aux interfac.des couches
@@ -138,5 +138,5 @@
 c    variables pour l'initialisation de la physique :
 c    ------------------------------------------------
-      INTEGER ngridmx,nq
+      INTEGER ngridmx
       PARAMETER( ngridmx = 2+(jjm-1)*iim - 1/jjm   )
       REAL zcufi(ngridmx),zcvfi(ngridmx)
@@ -159,16 +159,4 @@
       dynhistave_file = 'dyn_hist_ave'
 
-
-c initialisation Anne
-      hadv_flg(:) = 0.
-      vadv_flg(:) = 0.
-      conv_flg(:) = 0.
-      pbl_flg(:)  = 0. 
-      tracnam(:)  = '        ' 
-      nprath = 1
-      nbtrac = 0
-      mmt_adj(:,:,:,:) = 1
-
-
 c--------------------------------------------------------------------------
 c   Iflag_phys controle l'appel a la physique :
@@ -219,5 +207,5 @@
       call init_parallel
       call Read_Distrib
-      CALL Init_Phys_lmdz(iim,jjp1,llm,nqmx-2,mpi_size,distrib_phys)
+      CALL Init_Phys_lmdz(iim,jjp1,llm,mpi_size,distrib_phys)
       CALL set_bands
       CALL Init_interface_dyn_phys
@@ -238,5 +226,5 @@
 #ifdef INCA
          call init_const_lmdz(
-     $        nbtrac,anneeref,dayref,
+     $        nbtr,anneeref,dayref,
      $        iphysiq,day_step,nday)
 
@@ -250,9 +238,11 @@
 c   Initialisation des traceurs
 c   ---------------------------
-c  Choix du schema pour l'advection
-c  dans fichier trac.def ou via INCA
-
-       call iniadvtrac(nq)
-c
+c  Choix du nombre de traceurs et du schema pour l'advection
+c  dans fichier traceur.def, par default ou via INCA
+      call infotrac_init
+
+c Allocation de la tableau q : champs advectes   
+      ALLOCATE(q(ip1jmp1,llm,nqtot))
+
 c-----------------------------------------------------------------------
 c   Lecture de l'etat initial :
@@ -262,5 +252,5 @@
       if (read_start) then
 #ifdef CPP_IOIPSL
-         CALL dynetat0("start.nc",nqmx,vcov,ucov,
+         CALL dynetat0("start.nc",vcov,ucov,
      .              teta,q,masse,ps,phis, time_0)
 c       write(73,*) 'ucov',ucov
@@ -277,7 +267,6 @@
      .                 'AVANT iniacademic AVANT AVANT AVANT AVANT'
       if (.not.read_start) then
-         CALL iniacademic(nqmx,vcov,ucov,teta,q,masse,ps,phis,time_0)
+         CALL iniacademic(vcov,ucov,teta,q,masse,ps,phis,time_0)
       endif
-
 
 c-----------------------------------------------------------------------
@@ -414,5 +403,5 @@
 
 #ifdef CPP_IOIPSL
-      CALL dynredem0_p("restart.nc", day_end, phis, nqmx)
+      CALL dynredem0_p("restart.nc", day_end, phis)
 
       ecripar = .TRUE.
@@ -423,10 +412,10 @@
       t_wrt = iecri * daysec
       CALL inithist_p(dynhist_file,day_ref,annee_ref,time_step,
-     .              t_ops, t_wrt, nqmx, histid, histvid)
+     .              t_ops, t_wrt, histid, histvid)
 
       t_ops = iperiod * time_step
       t_wrt = periodav * daysec
       CALL initdynav_p(dynhistave_file,day_ref,annee_ref,time_step,
-     .              t_ops, t_wrt, nqmx, histaveid)
+     .              t_ops, t_wrt, histaveid)
 
       dtav = iperiod*dtvr/daysec
@@ -455,5 +444,5 @@
 
 c$OMP PARALLEL DEFAULT(SHARED) COPYIN(/temps/,/logic/)
-      CALL leapfrog_p(ucov,vcov,teta,ps,masse,phis,nq,q,clesphy0,
+      CALL leapfrog_p(ucov,vcov,teta,ps,masse,phis,q,clesphy0,
      .              time_0)
 c$OMP END PARALLEL
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/infotrac.F90
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/infotrac.F90	(revision 1114)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/infotrac.F90	(revision 1114)
@@ -0,0 +1,317 @@
+MODULE infotrac
+
+! nqtot : total number of tracers and higher order of moment, water vapor and liquid included
+  INTEGER, SAVE :: nqtot
+!$OMP THREADPRIVATE(nqtot)   
+
+! nbtr : number of tracers not including higher order of moment or water vapor or liquid
+!        number of tracers used in the physics
+  INTEGER, SAVE :: nbtr
+!$OMP THREADPRIVATE(nbtr)   
+
+! Name variables
+  CHARACTER(len=20), ALLOCATABLE, DIMENSION(:), SAVE :: tname ! tracer short name for restart and diagnostics
+  CHARACTER(len=23), ALLOCATABLE, DIMENSION(:), SAVE :: ttext ! tracer long name for diagnostics
+!$OMP THREADPRIVATE(tname,ttext)   
+
+! iadv  : index of trasport schema for each tracer
+  INTEGER, ALLOCATABLE, DIMENSION(:), SAVE    :: iadv
+!$OMP THREADPRIVATE(iadv)   
+
+! niadv : vector keeping the coorspondance between all tracers(nqtot) treated in the 
+!         dynamic part of the code and the tracers (nbtr+2) used in the physics part of the code. 
+  INTEGER, ALLOCATABLE, DIMENSION(:), SAVE    :: niadv ! equivalent dyn / physique
+!$OMP THREADPRIVATE(niadv)   
+
+! Variables for INCA
+  INTEGER, ALLOCATABLE, DIMENSION(:), SAVE  :: conv_flg
+  INTEGER, ALLOCATABLE, DIMENSION(:), SAVE  :: pbl_flg
+!$OMP THREADPRIVATE(conv_flg, pbl_flg)   
+
+CONTAINS
+
+  SUBROUTINE infotrac_init
+    IMPLICIT NONE
+!=======================================================================
+!
+!   Auteur:  P. Le Van /L. Fairhead/F.Hourdin
+!   -------
+!   Modif special traceur F.Forget 05/94
+!   Modif M-A Filiberti 02/02 lecture de traceur.def
+!
+!   Objet:
+!   ------
+!   GCM LMD nouvelle grille
+!
+!=======================================================================
+!   ... modification de l'integration de q ( 26/04/94 ) ....
+!-----------------------------------------------------------------------
+! Declarations
+
+    INCLUDE "dimensions.h"
+    INCLUDE "control.h"
+    INCLUDE "iniprint.h"
+
+! Local variables
+    INTEGER, ALLOCATABLE, DIMENSION(:) :: hadv  ! index of horizontal trasport schema
+    INTEGER, ALLOCATABLE, DIMENSION(:) :: vadv  ! index of vertical trasport schema
+
+    CHARACTER(len=8), ALLOCATABLE, DIMENSION(:) :: tnom_0  ! tracer short name
+    CHARACTER(len=8), ALLOCATABLE, DIMENSION(:) :: tracnam ! name from INCA
+    CHARACTER(len=3), DIMENSION(30) :: descrq
+    CHARACTER(len=1), DIMENSION(3)  :: txts
+    CHARACTER(len=2), DIMENSION(9)  :: txtp
+    CHARACTER(len=13)               :: str1,str2
+  
+    INTEGER :: nqtrue  ! number of tracers read from tracer.def, without higer order of moment
+    INTEGER :: iq, new_iq, iiq, jq, ierr
+    INTEGER, EXTERNAL :: lnblnk
+ 
+!-----------------------------------------------------------------------
+! Initialization :
+!
+    txts=(/'x','y','z'/)
+    txtp=(/'x ','y ','z ','xx','xy','xz','yy','yz','zz'/)
+
+    descrq(14)='VLH'
+    descrq(10)='VL1'
+    descrq(11)='VLP'
+    descrq(12)='FH1'
+    descrq(13)='FH2'
+    descrq(16)='PPM'
+    descrq(17)='PPS'
+    descrq(18)='PPP'
+    descrq(20)='SLP'
+    descrq(30)='PRA'
+
+!-----------------------------------------------------------------------
+!
+! 1) Get the true number of tracers + water vapor/liquid
+!    Here true tracers (nqtrue) means declared tracers (only first order)
+!
+!-----------------------------------------------------------------------
+    IF (config_inca == 'none') THEN
+       OPEN(90,file='traceur.def',form='formatted',status='old', iostat=ierr)
+       IF(ierr.EQ.0) THEN
+          WRITE(lunout,*) 'Open traceur.def : ok'
+          READ(90,*) nqtrue
+       ELSE 
+          WRITE(lunout,*) 'Problem in opening traceur.def'
+          WRITE(lunout,*) 'ATTENTION using defaut values'
+          nqtrue=4 ! Defaut value
+       END IF
+       ! Attention! Only for planet_type=='earth'
+       nbtr=nqtrue-2
+    ELSE
+       ! nbtr has been read from INCA by init_cont_lmdz() in gcm.F 
+       nqtrue=nbtr+2
+    END IF
+
+    IF (nqtrue < 2) THEN
+       WRITE(lunout,*) 'nqtrue=',nqtrue, ' is not allowded. 2 tracers is the minimum'
+       CALL abort_gcm('infotrac_init','Not enough tracers',1)
+    END IF
+!
+! Allocate variables depending on nqtrue
+!
+    ALLOCATE(tnom_0(nqtrue), hadv(nqtrue), vadv(nqtrue))
+
+    IF (config_inca /= 'none') THEN
+       ! Varaibles only needed in case of INCA
+       ALLOCATE(conv_flg(nbtr), pbl_flg(nbtr), tracnam(nbtr))
+    END IF
+       
+!-----------------------------------------------------------------------
+! 2)     Choix  des schemas d'advection pour l'eau et les traceurs
+!
+!     iadv = 1    schema  transport type "humidite specifique LMD"
+!     iadv = 2    schema   amont
+!     iadv = 14   schema  Van-leer + humidite specifique 
+!                            Modif F.Codron
+!     iadv = 10   schema  Van-leer (retenu pour l'eau vapeur et liquide)
+!     iadv = 11   schema  Van-Leer pour hadv et version PPM (Monotone) pour vadv
+!     iadv = 12   schema  Frederic Hourdin I
+!     iadv = 13   schema  Frederic Hourdin II
+!     iadv = 16   schema  PPM Monotone(Collela & Woodward 1984)
+!     iadv = 17   schema  PPM Semi Monotone (overshoots autorisés)
+!     iadv = 18   schema  PPM Positif Defini (overshoots undershoots autorisés)
+!     iadv = 20   schema  Slopes
+!     iadv = 30   schema  Prather
+!
+!        Dans le tableau q(ij,l,iq) : iq = 1  pour l'eau vapeur
+!                                     iq = 2  pour l'eau liquide
+!       Et eventuellement             iq = 3,nqtot pour les autres traceurs
+!
+!        iadv(1): choix pour l'eau vap. et  iadv(2) : choix pour l'eau liq.
+!------------------------------------------------------------------------
+!
+!    Get choice of advection schema from file tracer.def or from INCA
+!---------------------------------------------------------------------
+    IF (config_inca == 'none') THEN
+       IF(ierr.EQ.0) THEN
+          ! Continue to read tracer.def
+          DO iq=1,nqtrue
+             READ(90,999) hadv(iq),vadv(iq),tnom_0(iq)
+          END DO
+          CLOSE(90)  
+       ELSE ! Without tracer.def
+          hadv(1) = 14
+          vadv(1) = 14
+          tnom_0(1) = 'H2Ov'
+          hadv(2) = 10
+          vadv(2) = 10
+          tnom_0(2) = 'H2Ol'
+          hadv(3) = 10
+          vadv(3) = 10
+          tnom_0(3) = 'RN'
+          hadv(4) = 10
+          vadv(4) = 10
+          tnom_0(4) = 'PB'
+       END IF
+       
+       WRITE(lunout,*) 'Valeur de traceur.def :'
+       WRITE(lunout,*) 'nombre de traceurs ',nqtrue
+       DO iq=1,nqtrue
+          WRITE(lunout,*) hadv(iq),vadv(iq),tnom_0(iq)
+       END DO
+
+    ELSE  ! config_inca='aero' ou 'chem'
+! le module de chimie fournit les noms des traceurs
+! et les schemas d'advection associes.
+     
+#ifdef INCA
+       CALL init_transport( &
+            hadv, &
+            vadv, &
+            conv_flg, &
+            pbl_flg,  &
+            tracnam)
+#endif
+       tnom_0(1)='H2Ov'
+       tnom_0(2)='H2Ol'
+
+       DO iq =3,nqtrue
+          tnom_0(iq)=tracnam(iq-2)
+       END DO
+
+    END IF ! config_inca
+
+!-----------------------------------------------------------------------
+!
+! 3) Verify if advection schema 20 or 30 choosen
+!    Calculate total number of tracers needed: nqtot
+!    Allocate variables depending on total number of tracers
+!-----------------------------------------------------------------------
+    new_iq=0
+    DO iq=1,nqtrue
+       ! Add tracers for certain advection schema
+       IF (hadv(iq)<20 .AND. vadv(iq)<20 ) THEN
+          new_iq=new_iq+1  ! no tracers added
+       ELSE IF (hadv(iq)==20 .AND. vadv(iq)==20 ) THEN
+          new_iq=new_iq+4  ! 3 tracers added
+       ELSE IF (hadv(iq)==30 .AND. vadv(iq)==30 ) THEN
+          new_iq=new_iq+10 ! 9 tracers added
+       ELSE
+          WRITE(lunout,*) 'This choice of advection schema is not available'
+          CALL abort_gcm('infotrac_init','Bad choice of advection schema - 1',1)
+       END IF
+    END DO
+    
+    IF (new_iq /= nqtrue) THEN
+       ! The choice of advection schema imposes more tracers
+       ! Assigne total number of tracers
+       nqtot = new_iq
+
+       WRITE(lunout,*) 'The choice of advection schema for one or more tracers'
+       WRITE(lunout,*) 'makes it necessary to add tracers'
+       WRITE(lunout,*) nqtrue,' is the number of true tracers'
+       WRITE(lunout,*) nqtot, ' is the total number of tracers needed'
+
+    ELSE
+       ! The true number of tracers is also the total number
+       nqtot = nqtrue
+    END IF
+
+!
+! Allocate variables with total number of tracers, nqtot
+!
+    ALLOCATE(tname(nqtot), ttext(nqtot))
+    ALLOCATE(iadv(nqtot), niadv(nqtot))
+
+!-----------------------------------------------------------------------
+!
+! 4) Determine iadv, long and short name
+!
+!-----------------------------------------------------------------------
+    new_iq=0
+    DO iq=1,nqtrue
+       new_iq=new_iq+1
+
+       ! Verify choice of advection schema
+       IF (hadv(iq)==vadv(iq)) THEN
+          iadv(new_iq)=hadv(iq)
+       ELSE IF (hadv(iq)==10 .AND. vadv(iq)==16) THEN
+          iadv(new_iq)=11
+       ELSE
+          WRITE(lunout,*)'This choice of advection schema is not available'
+          CALL abort_gcm('infotrac_init','Bad choice of advection schema - 2',1)
+       END IF
+      
+       str1=tnom_0(iq)
+       tname(new_iq)= tnom_0(iq)
+       IF (iadv(new_iq)==0) THEN
+          ttext(new_iq)=str1(1:lnblnk(str1))
+       ELSE
+          ttext(new_iq)=str1(1:lnblnk(str1))//descrq(iadv(new_iq))
+       END IF
+
+       ! schemas tenant compte des moments d'ordre superieur
+       str2=ttext(new_iq)
+       IF (iadv(new_iq)==20) THEN
+          DO jq=1,3
+             new_iq=new_iq+1
+             iadv(new_iq)=-20
+             ttext(new_iq)=str2(1:lnblnk(str2))//txts(jq)
+             tname(new_iq)=str1(1:lnblnk(str1))//txts(jq)
+          END DO
+       ELSE IF (iadv(new_iq)==30) THEN
+          DO jq=1,9
+             new_iq=new_iq+1
+             iadv(new_iq)=-30
+             ttext(new_iq)=str2(1:lnblnk(str2))//txtp(jq)
+             tname(new_iq)=str1(1:lnblnk(str1))//txtp(jq)
+          END DO
+       END IF
+    END DO
+
+!
+! Find vector keeping the correspodence between true and total tracers
+!
+    niadv(:)=0
+    iiq=0
+    DO iq=1,nqtot
+       IF(iadv(iq).GE.0) THEN
+          ! True tracer
+          iiq=iiq+1
+          niadv(iiq)=iq
+       ENDIF
+    END DO
+
+
+    WRITE(lunout,*) 'Information stored in dimtrac :'
+    WRITE(lunout,*) 'iadv  niadv tname  ttext :'
+    DO iq=1,nqtot
+       WRITE(lunout,*) iadv(iq),niadv(iq), tname(iq), ttext(iq)
+    END DO
+
+!-----------------------------------------------------------------------
+! Finalize :
+!
+    DEALLOCATE(tnom_0, hadv, vadv)
+    IF (config_inca /= 'none') DEALLOCATE(tracnam)
+
+999 FORMAT (i2,1x,i2,1x,a8)
+
+  END SUBROUTINE infotrac_init
+
+END MODULE infotrac
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/iniacademic.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/iniacademic.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/iniacademic.F	(revision 1114)
@@ -4,7 +4,8 @@
 c
 c
-      SUBROUTINE iniacademic(nq,vcov,ucov,teta,q,masse,ps,phis,time_0)
+      SUBROUTINE iniacademic(vcov,ucov,teta,q,masse,ps,phis,time_0)
 
       USE filtreg_mod
+      USE infotrac, ONLY : nqtot
 
 c%W%    %G%
@@ -48,5 +49,4 @@
 c   ----------
 
-      integer nq
       real time_0
 
@@ -54,5 +54,5 @@
       REAL vcov(ip1jm,llm),ucov(ip1jmp1,llm) ! vents covariants
       REAL teta(ip1jmp1,llm)                 ! temperature potentielle
-      REAL q(ip1jmp1,llm,nq)               ! champs advectes
+      REAL q(ip1jmp1,llm,nqtot)              ! champs advectes
       REAL ps(ip1jmp1)                       ! pression  au sol
       REAL masse(ip1jmp1,llm)                ! masse d'air
@@ -160,5 +160,5 @@
       q(:,:,1   )=1.e-10
       q(:,:,2   )=1.e-15
-      q(:,:,3:nq)=0.
+      q(:,:,3:nqtot)=0.
 
 
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/initdynav_p.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/initdynav_p.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/initdynav_p.F	(revision 1114)
@@ -4,6 +4,5 @@
 c
 c
-      subroutine initdynav_p(infile,day0,anne0,tstep,t_ops,t_wrt
-     .                     ,nq,fileid)
+      subroutine initdynav_p(infile,day0,anne0,tstep,t_ops,t_wrt,fileid)
 
        USE IOIPSL
@@ -11,4 +10,6 @@
        use Write_field
        use misc_mod
+       USE infotrac
+
       implicit none
 
@@ -30,5 +31,4 @@
 C      t_ops: frequence de l'operation pour IOIPSL
 C      t_wrt: frequence d'ecriture sur le fichier
-C      nq: nombre de traceurs
 C
 C   Sortie:
@@ -50,5 +50,4 @@
 #include "description.h"
 #include "serre.h"
-#include "advtrac.h"
 
 C   Arguments
@@ -58,5 +57,4 @@
       real tstep, t_ops, t_wrt
       integer fileid
-      integer nq
       integer thoriid, zvertiid
 
@@ -82,5 +80,4 @@
       
       INTEGER :: dynave_domain_id
-      
       
       if (adjust) return
@@ -169,5 +166,5 @@
 C  Traceurs
 C
-        DO iq=1,nq
+        DO iq=1,nqtot
           call histdef(fileid, ttext(iq), ttext(iq), '-',
      .             iip1, jjn, thoriid, llm, 1, llm, zvertiid,
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/initfluxsto_p.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/initfluxsto_p.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/initfluxsto_p.F	(revision 1114)
@@ -3,5 +3,5 @@
 !
       subroutine initfluxsto_p
-     .  (infile,tstep,t_ops,t_wrt,nq,
+     .  (infile,tstep,t_ops,t_wrt,
      .                    fileid,filevid,filedid)
 
@@ -30,5 +30,4 @@
 C      t_ops: frequence de l'operation pour IOIPSL
 C      t_wrt: frequence d'ecriture sur le fichier
-C      nq: nombre de traceurs
 C
 C   Sortie:
@@ -58,5 +57,5 @@
       real tstep, t_ops, t_wrt
       integer fileid, filevid,filedid
-      integer nq,ndex(1)
+      integer ndex(1)
       real nivd(1)
 
@@ -87,5 +86,4 @@
       INTEGER :: dynu_domain_id
       INTEGER :: dynv_domain_id
-
 
 C
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/inithist_p.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/inithist_p.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/inithist_p.F	(revision 1114)
@@ -2,5 +2,5 @@
 ! $Header$
 !
-      subroutine inithist_p(infile,day0,anne0,tstep,t_ops,t_wrt,nq,
+      subroutine inithist_p(infile,day0,anne0,tstep,t_ops,t_wrt,
      .                      fileid,filevid)
 
@@ -9,4 +9,5 @@
        use Write_field
        use misc_mod
+       USE infotrac
 
       implicit none
@@ -29,5 +30,4 @@
 C      t_ops: frequence de l'operation pour IOIPSL
 C      t_wrt: frequence d'ecriture sur le fichier
-C      nq: nombre de traceurs
 C
 C   Sortie:
@@ -50,5 +50,4 @@
 #include "description.h"
 #include "serre.h"
-#include "advtrac.h"
 
 C   Arguments
@@ -58,5 +57,4 @@
       real tstep, t_ops, t_wrt
       integer fileid, filevid
-      integer nq
 
 C   Variables locales
@@ -83,4 +81,5 @@
       INTEGER :: dynu_domain_id
       INTEGER :: dynv_domain_id
+
 C
 C  Initialisations
@@ -217,5 +216,5 @@
 C  Traceurs
 C
-        DO iq=1,nq
+        DO iq=1,nqtot
           call histdef(fileid, ttext(iq),  ttext(iq), '-',
      .             iip1, jjn, thoriid, llm, 1, llm, zvertiid,
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/integrd_p.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/integrd_p.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/integrd_p.F	(revision 1114)
@@ -32,5 +32,4 @@
 #include "temps.h"
 #include "serre.h"
-#include "advtrac.h"
 
 c   Arguments:
